package com.pancik.libgdx.zumpatalentov.engine;

import com.pancik.libgdx.zumpatalentov.util.HandlerID;

public abstract class IDObject implements Comparable<IDObject> {
    private Long id;

    public Long getId() {
        return id;
    }
    
    public void setId(Long id) {
        this.id = id;
        HandlerID.updateId(id);
    }
        
    public IDObject() {
        this.id = HandlerID.getId();
    }
    
    @Override
    public int compareTo(IDObject o) {
        if(o.getId() < getId()) {
            return 1;
        } else if(o.getId() > getId()) {
            return -1;
        } else {
            return 0;
        }
    }
    
    @Override
    public int hashCode() {
        return getId().hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final IDObject other = (IDObject) obj;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }
}
