package com.pancik.libgdx.zumpatalentov.engine.particle;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.util.RandomGenerator;
import com.pancik.libgdx.zumpatalentov.util.RenderUtils;

public class LightningParticle implements Particle {
    public static Texture LIGHTNING_EFFECT_TEXTURE = DrawableData.textures.get("lightning_particle");
    public static final int TEX_SINGLE_WIDTH = 256;
    public static final int TEX_SINGLE_HEIGHT = 64;
    private static final int PARTICLE_LIFETIME = 8;
    
    private Vector2 pos;
    private Vector2 size;
    private float rotation;
    private int lifetime = 0;
    private int image = RandomGenerator.getRandom(4);
    
    public LightningParticle(Vector2 pos, Vector2 size, float rotation) {
        this.pos = pos;
        this.size = size;
        this.rotation = rotation;
    }

    @Override
    public void tick() {
        lifetime++;
    }

    @Override
    public void earlyRender() {
    }

    @Override
    public void lateRender() {
        RenderUtils.blit(DrawableData.spriteBatch,
                LIGHTNING_EFFECT_TEXTURE,
                new RenderUtils.ScreenInfo(pos.x - size.x/2, pos.y - size.y/2, size.x, size.y),
                new RenderUtils.ScreenInfo(0, TEX_SINGLE_HEIGHT * image, TEX_SINGLE_WIDTH, TEX_SINGLE_HEIGHT), rotation);
    }

    @Override
    public boolean remove() {
        if(lifetime >= PARTICLE_LIFETIME) {
            return true;
        } else {
            return false;
        }
    }
}
