package com.pancik.libgdx.zumpatalentov.engine.particle;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.util.RenderUtils;

public class PurplePowderExplosion implements Particle {
    public static Texture PURPLE_EXPLOSION = DrawableData.textures.get("purple_explosion");
    
    protected static final int TEX_X = 128;
    protected static final int TEX_Y = 128;
    public static final int[] ANIMATION_STEPS = {0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,6,7,7,7,7};
    
    private int currentStep = 0;
    private Vector2 pos;
    private float diameter;

    public PurplePowderExplosion(Vector2 pos, float diameter) {
        this.pos = pos;
        this.diameter = diameter;
    }

    @Override
    public void tick() {
        currentStep++;
    }

    @Override
    public void earlyRender() {
    }

    @Override
    public void lateRender() {
        RenderUtils.blit(DrawableData.spriteBatch,
                PURPLE_EXPLOSION,
                new RenderUtils.ScreenInfo(pos.x - diameter/2, pos.y - diameter/2, diameter, diameter),
                new RenderUtils.ScreenInfo(TEX_X * ANIMATION_STEPS[currentStep], 0, TEX_X, TEX_Y));
    }

    @Override
    public boolean remove() {
        return (currentStep >= ANIMATION_STEPS.length);
    }
}
