package com.pancik.libgdx.zumpatalentov.engine.ui;

import com.badlogic.gdx.graphics.Texture;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.ui.ButtonHorizontalAlignment;
import com.pancik.libgdx.zumpatalentov.ui.ButtonVerticalAlignment;
import com.pancik.libgdx.zumpatalentov.util.RenderUtils;

public enum Icon {
    TESLA_COIL(IconDrawables.TESLA_COIL_ICON, 64, 64),
    CANCEL(IconDrawables.CANCEL_ICON, 64, 64),
    COIN(IconDrawables.COIN_ICON, 128, 128),
    FRANKIE(IconDrawables.FRANKIE_ICON, 64, 64),
    TOFU(IconDrawables.TOFU_ICON, 128, 128),
    MUTATE_LAB(IconDrawables.MUTATE_LAB_ICON, 64, 64),
    TOFU_TOWER(IconDrawables.TOFU_TOWER_ICON, 64, 64),
    DESTROY(IconDrawables.DESTROY_ICON, 64, 64),
    DESTROY_NOBORDER(IconDrawables.DESTROY_NOBORDER, 64, 64),
    
    UPGRADE_HEART(IconDrawables.UPGRADE_HEART, 128, 128),
    UPGRADE_ATTACK_SPEED(IconDrawables.UPGRADE_ATTACK_SPEED, 128, 128),
    UPGRADE_EXPLOSION(IconDrawables.UPGRADE_EXPLOSION, 128, 128),
    UPGRADE_MOV_SPEED(IconDrawables.UPGRADE_MOV_SPEED, 128, 128),
    UPGRADE_MUSCLE(IconDrawables.UPGRADE_MUSCLE, 128, 128),
    UPGRADE_SPAWN_SPEED(IconDrawables.UPGRADE_SPAWN_SPEED, 128, 128),
    
    UPGRADE_PERMANENT_ATTACK_SPEED(IconDrawables.UPGRADE_PERMANENT_ATTACK_SPEED, 128, 128),
    UPGRADE_PERMANENT_MOV_SPEED(IconDrawables.UPGRADE_PERMANENT_MOV_SPEED, 128, 128),
    UPGRADE_PERMANENT_MUSCLE(IconDrawables.UPGRADE_PERMANENT_MUSCLE, 128, 128),
    UPGRADE_PERMANENT_SPAWN_SPEED(IconDrawables.UPGRADE_PERMANENT_SPAWN_SPEED, 128, 128),
    
    BODY_PART_HEAD_BATMAN(IconDrawables.BODY_PART_ICON_HEAD_BATMAN, 64, 64),
    BODY_PART_HEAD_BIGNOSE(IconDrawables.BODY_PART_ICON_HEAD_BIGNOSE, 64, 64),
    BODY_PART_HEAD_BUNNY(IconDrawables.BODY_PART_ICON_HEAD_BUNNY, 64, 64),
    BODY_PART_TORSO_MELEE(IconDrawables.BODY_PART_ICON_TORSO_MELEE, 64, 64),
    BODY_PART_TORSO_ONEHAND(IconDrawables.BODY_PART_ICON_TORSO_ONEHAND, 64, 64),
    BODY_PART_TORSO_TWOHAND(IconDrawables.BODY_PART_ICON_TORSO_TWOHAND, 64, 64),
    BODY_PART_LEGS_TWO(IconDrawables.BODY_PART_ICON_LEGS_TWO, 64, 64),
    BODY_PART_LEGS_THREE(IconDrawables.BODY_PART_ICON_LEGS_THREE, 64, 64),
    BODY_PART_LEGS_FOUR(IconDrawables.BODY_PART_ICON_LEGS_FOUR, 64, 64);

    private Icon(Texture iconTexture, int textureSizeX, int textureSizeY) {
        this.iconTexture = iconTexture;
        this.textureSizeX = textureSizeX;
        this.textureSizeY = textureSizeY;
    }
    private Texture iconTexture;
    private int textureSizeX;
    private int textureSizeY;

    public Texture getIconTexture() {
        return iconTexture;
    }

    public void render(int posX, int posY, int sizeX, int sizeY) {
        RenderUtils.blit(DrawableData.spriteBatch,
                iconTexture,
                new RenderUtils.ScreenInfo(posX - sizeX / 2, posY - sizeY / 2, sizeX, sizeY),
                new RenderUtils.ScreenInfo(0, 0, textureSizeX, textureSizeY));
    }
    
    public void renderUI(ButtonHorizontalAlignment horizontal, int deltaX, ButtonVerticalAlignment vertical, int deltaY, int sizeX, int sizeY) {
        int densitySizeX = (int)((float)sizeX * DrawableData.getDensity());
        int densitySizeY = (int)((float)sizeY * DrawableData.getDensity());
        
        int posX = RenderUtils.calculateX(horizontal, deltaX, densitySizeX);
        int posY = RenderUtils.calculateY(vertical, deltaY, densitySizeY);
        
        RenderUtils.blit(DrawableData.spriteBatch,
                iconTexture,
                new RenderUtils.ScreenInfo(posX, posY, densitySizeX, densitySizeY),
                new RenderUtils.ScreenInfo(0, 0, textureSizeX, textureSizeY));
    }
}
