package com.pancik.libgdx.zumpatalentov.engine.ui.window;

import com.badlogic.gdx.graphics.Color;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.ui.ButtonHorizontalAlignment;
import com.pancik.libgdx.zumpatalentov.ui.ButtonVerticalAlignment;
import com.pancik.libgdx.zumpatalentov.util.MouseEvent;
import com.pancik.libgdx.zumpatalentov.util.RenderUtils;

public class WindowText implements WindowUIElement {

    protected ButtonHorizontalAlignment horizontal;
    protected int deltaX;
    protected ButtonVerticalAlignment vertical;
    protected int deltaY;
    protected String text;
    protected RenderUtils.TextAlligment textHorizontal;
    protected RenderUtils.TextAlligment textVertical;
    protected Color color;

    protected int offsetX;
    protected int offsetY;
    protected int sizeX;
    protected int sizeY;
    
    public WindowText(ButtonHorizontalAlignment horizontal, int deltaX, ButtonVerticalAlignment vertical, int deltaY,
            String text, RenderUtils.TextAlligment textHorizontal, RenderUtils.TextAlligment textVertical, Color color) {
        this.horizontal = horizontal;
        this.deltaX = deltaX;
        this.vertical = vertical;
        this.deltaY = deltaY;
        this.text = text;
        this.textHorizontal = textHorizontal;
        this.textVertical = textVertical;
        this.color = color;
    }
    
    public WindowText(ButtonHorizontalAlignment horizontal, int deltaX, ButtonVerticalAlignment vertical, int deltaY,
            String text, RenderUtils.TextAlligment textHorizontal, RenderUtils.TextAlligment textVertical) {
        this(horizontal, deltaX, vertical, deltaY, text, textHorizontal, textVertical, Color.BLACK);
    }
    
    @Override
    public void tick(float mousePosX, float mousePosY, boolean hidden) {
    }

    @Override
    public void render(int x, int y, int sizeX, int sizeY) {
        updateCoords(x, y, sizeX, sizeY);
        
        RenderUtils.blitText(DrawableData.spriteBatch, text, calculateX(), calculateY(), color, textHorizontal, textVertical);
    }
    
    public void updateCoords(int x, int y, int sizeX, int sizeY) {
        this.offsetX = x;
        this.offsetY = y;
        this.sizeX = sizeX;
        this.sizeY = sizeY;
    }

    @Override
    public void handle(MouseEvent me) {
    }
    
    public void setText(String text) {
        this.text = text;
    }
    
    public int calculateX() {
        int width = sizeX;

        switch(horizontal) {
            case LEFT:
                return offsetX + (int)(deltaX * DrawableData.getDensity());
            case MIDDLE:
                return offsetX + (width/2) + (int)(deltaX * DrawableData.getDensity());
            case RIGHT:
                return offsetX + width + (int)(deltaX * DrawableData.getDensity());
        }
        return -1;
    }

    public int calculateY() {
        int height = sizeY;

        switch(vertical) {
            case TOP:
                return offsetY + (int)(deltaY * DrawableData.getDensity());
            case MIDDLE:
                return offsetY + (height/2) + (int)(deltaY * DrawableData.getDensity());
            case BOTTOM:
                return offsetY + height + (int)(deltaY * DrawableData.getDensity());
        }
        return -1;
    }
}
