package com.pancik.libgdx.zumpatalentov.entity;

import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.engine.Engine;
import com.pancik.libgdx.zumpatalentov.engine.Engine.EngineControls;
import com.pancik.libgdx.zumpatalentov.entity.attackable.AttackableEntity;
import com.pancik.libgdx.zumpatalentov.entity.unit.UnitEntity;
import java.util.List;

public class WaypointAttackAI extends WaypointAI {
    protected Engine.EngineControls engineControls;
    
    protected AttackableEntity target = null;

    public WaypointAttackAI(EngineControls engineControls) {
        this.engineControls = engineControls;
    }
    
    @Override
    public void tick(UnitEntity e) {
        if(target != null) {
            if(target.isDead()) {
                target = null;
            }
        }
        
        if(target == null) {
            List<AttackableEntity> found = engineControls.getEntityManager().getAttackableEntities(e.getPos(), e.getAttackSightRange());
            AttackableEntity closest = null;
            for(AttackableEntity u : found) {
                if(u != e && u.getTeam() != e.getTeam() && !u.isDead()) {
                    if(closest == null) {
                        closest = u;
                    } else {
                        if(u.getPos().sub(e.getPos()).len() < closest.getPos().sub(e.getPos()).len()) {
                            closest = u;
                        }
                    }
                    break;
                }
            }
            
            target = closest;
        
            if(target == null) {
                super.tick(e);
            }
        } else {
            Vector2 targetPos = target.getPos();
            targetPos.sub(e.getPos());
            
            if(targetPos.len() > e.getAttackRange()) {
                this.goToTarget(e, target.getPos());
            } else {
                if(!e.tryAttack(target)) {
                    //this.goToTarget(e, target.getPos());
                }
            }
        }
    }
    
}
