package com.pancik.libgdx.zumpatalentov.entity.projectile;

import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.entity.attackable.AttackableEntity;
import com.pancik.libgdx.zumpatalentov.util.RandomGenerator;

public abstract class HomingProjectile extends Projectile {

    protected AttackableEntity target;
    protected Vector2 offset;
    
    public HomingProjectile(AttackableEntity target, Vector2 pos, float diameter, float speed, Callback callback) {
        super(target.getPos(), Math.min(target.getSize().x, target.getSize().y), pos, diameter, speed, callback);
        this.target = target;
        this.offset = HomingProjectile.offsetRandomPos(target.getPos(), target.getSize());
    }

    @Override
    public void tick() {
        this.targetPos = target.getPos().add(offset);
        
        super.tick();
    }
    
    public static Vector2 offsetRandomPos(Vector2 pos, Vector2 size) {
        Vector2 topLeft = pos.cpy().sub(size.cpy().mul(0.5f));
        
        int xCoord = RandomGenerator.getRandom((int)size.x);
        int yCoord = RandomGenerator.getRandom((int)size.y);
        
        return new Vector2(topLeft.x + xCoord, topLeft.y + yCoord).sub(pos);
    }
}
