package com.pancik.libgdx.zumpatalentov.entity.projectile;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.engine.Engine;
import com.pancik.libgdx.zumpatalentov.engine.particle.SmallExplosion;
import com.pancik.libgdx.zumpatalentov.entity.attackable.AttackableEntity;
import com.pancik.libgdx.zumpatalentov.util.RenderUtils;

public class LaserHomingProjectile extends HomingProjectile {
    public static Texture LASER_TEXTURE = DrawableData.textures.get("laser_projectile");
    
    public static final int TEX_SIZE_X = 64;
    public static final int TEX_SIZE_Y = 64;
    public static final float DIAMETER = 24.0f;
    public static final float SPEED = 8.0f;
    
    private Engine.EngineControls engineControls;
    
    public LaserHomingProjectile(AttackableEntity target, Vector2 pos, Callback callback, Engine.EngineControls engineControls) {
        super(target, pos, DIAMETER, SPEED, callback);
        this.engineControls = engineControls;
    }
    
    @Override
    public void render() {
        RenderUtils.blit(DrawableData.spriteBatch,
                LASER_TEXTURE,
                new RenderUtils.ScreenInfo(pos.x - diameter/2, pos.y - diameter/2, diameter, diameter),
                new RenderUtils.ScreenInfo(0, 0, TEX_SIZE_X, TEX_SIZE_Y), angle);
    }

    @Override
    public void onRemove() {
    }

    @Override
    protected void onProjectileArrived() {
        engineControls.addParticle(new SmallExplosion(pos, diameter));
    }
}
