package com.pancik.libgdx.zumpatalentov.entity.unit.bodypart;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.math.Vector2;
import com.pancik.libgdx.zumpatalentov.DrawableData;
import com.pancik.libgdx.zumpatalentov.util.RenderUtils;

public class BatmanHead extends HeadBodyPart {
    public static Texture HEAD_BATMAN_MOVE = DrawableData.textures.get("batman_head");
    
    protected static final int[] ANIMATION_STEPS = {0,0,0,0,0,0,0, 1,1,1,1,1,1,1, 2,2,2,2,2,2,2, 3,3,3,3,3,3,3};

    @Override
    public void tick() {
    }

    @Override
    public void render(Vector2 pos, Vector2 size, int animationStep, int animationDirection, boolean attacked) {
        RenderUtils.blit(DrawableData.spriteBatch,
                HEAD_BATMAN_MOVE,
                new RenderUtils.ScreenInfo(pos.x - size.x/2, pos.y - size.y/2, size.x, size.y),
                new RenderUtils.ScreenInfo(TEX_SIZE_X * ANIMATION_STEPS[animationStep % ANIMATION_STEPS.length], TEX_SIZE_Y * animationDirection, TEX_SIZE_X, TEX_SIZE_Y));
    }

    @Override
    public int getHealth() {
        return 150;
    }
}
