package com.pancik.libgdx.zumpatalentov.entity.unit.bodypart;

import com.pancik.libgdx.zumpatalentov.engine.player.manager.ResourceManager;
import com.pancik.libgdx.zumpatalentov.engine.player.manager.ResourceManager.CostWrapper;

public abstract class HeadBodyPart implements BodyPart {
    public static enum Type {
        BATMAN (new CostWrapper(10, 0)),
        BIGNOSE (new CostWrapper(30, 0)),
        BUNNY (new CostWrapper(60, 20));
        
        private ResourceManager.CostWrapper cost;

        private Type(CostWrapper cost) {
            this.cost = cost;
        }

        public CostWrapper getCost() {
            return cost;
        }
    }
    
    //public static Texture HEAD_BATMAN_MOVE = new Texture(Gdx.files.internal("data/drawable/unit/bodypart/head_batman_move.png"));
    //public static Texture HEAD_BIGNOSE_MOVE = new Texture(Gdx.files.internal("data/drawable/unit/bodypart/head_bignose_move.png"));
    //public static Texture HEAD_BUNNY_MOVE = new Texture(Gdx.files.internal("data/drawable/unit/bodypart/head_bunny_move.png"));

    public static int TEX_SIZE_X = 256;
    public static int TEX_SIZE_Y = 256;
    
    public abstract int getHealth();
    
    public static HeadBodyPart getHeadBodyPart(Type type) {
        HeadBodyPart out = null;
        
        switch(type) {
            case BATMAN:
                out = new BatmanHead();
                break;
            case BIGNOSE:
                out = new BignoseHead();
                break;
            case BUNNY:
                out = new BunnyHead();
                break;
        }
        
        return out;
    }
}
