package com.pancik.libgdx.zumpatalentov.entity.unit.bodypart;

import com.pancik.libgdx.zumpatalentov.engine.player.manager.ResourceManager;
import com.pancik.libgdx.zumpatalentov.engine.player.manager.ResourceManager.CostWrapper;

public abstract class LegsBodyPart implements BodyPart {
    public static enum Type {
        TWO (new CostWrapper(20, 0)),
        THREE (new CostWrapper(40, 30)),
        FOUR (new CostWrapper(60, 50));
        
        private ResourceManager.CostWrapper cost;

        private Type(ResourceManager.CostWrapper cost) {
            this.cost = cost;
        }

        public ResourceManager.CostWrapper getCost() {
            return cost;
        }
    }
    
    //public static Texture LEGS_TWO_MOVE = new Texture(Gdx.files.internal("data/drawable/unit/bodypart/legs_two_move.png"));
    //public static Texture LEGS_THREE_MOVE = new Texture(Gdx.files.internal("data/drawable/unit/bodypart/legs_three_move.png"));
    //public static Texture LEGS_FOUR_MOVE = new Texture(Gdx.files.internal("data/drawable/unit/bodypart/legs_four_move.png"));

    public static int TEX_SIZE_X = 256;
    public static int TEX_SIZE_Y = 256;
    
    public abstract float getMovementSpeed();
    
    public static LegsBodyPart getTorsoBodyPart(Type type) {
        LegsBodyPart out = null;
        
        switch(type) {
            case TWO:
                out = new TwoLegs();
                break;
            case THREE:
                out = new ThreeLegs();
                break;
            case FOUR:
                out = new FourLegs();
                break;
        }
        
        return out;
    }
}
