package com.pancik.libgdx.zumpatalentov.ui;

import com.pancik.libgdx.zumpatalentov.util.MouseEvent;
import java.util.ArrayList;
import java.util.List;

public class UIHandler {
    private List<ClickableButton> clickableButtons = new ArrayList<ClickableButton>();

    public void addButton(ClickableButton b) {
        clickableButtons.add(b);
    }

    public boolean hitsAtLeastOneElement(MouseEvent me) {
        for(ClickableButton b : clickableButtons) {
           if(b.checkIfClicked(me.getUiUnprojectedX(), me.getUiUnprojectedY())) {
               return true;
           }
        }

        return false;
    }

    public void handle(MouseEvent me) {
        for(ClickableButton b : clickableButtons) {
            b.handle(me);
        }
    }

    public void render() {
        for(ClickableButton b : clickableButtons) {
            b.render();
        }
    }
}